/* 
   MySQLContext.m

   Copyright (C) 2000 Free Software Foundation, Inc.

   Author: Stephen Peters <portnoy@portnoy.org>
	      based on the Postgres95 Adaptor written by 
	   Mircea Oancea <mircea@jupiter.elcom.pub.ro>
   Date: August 2000

   This file is part of the GNUstep Database Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <Foundation/NSString.h>
#include <Foundation/NSArray.h>
#include <Foundation/NSValue.h>

#include <eoadaptors/MySQL/MySQLAdaptor.h>
#include <eoadaptors/MySQL/MySQLContext.h>
#include <eoadaptors/MySQL/MySQLChannel.h>

@implementation MySQLContext

- (BOOL)primaryBeginTransaction
{
    if ([self serverCanHandleTransactions]) 
	return [[[channels objectAtIndex:0] nonretainedObjectValue]
		   evaluateExpression:@"BEGIN"];
    else 
	return YES;
}

- (BOOL)primaryCommitTransaction
{
    if ([self serverCanHandleTransactions]) 
	return [[[channels objectAtIndex:0] nonretainedObjectValue]
		   evaluateExpression:@"COMMIT"];
    else 
	return YES;
}

- (BOOL)primaryRollbackTransaction
{
    if ([self serverCanHandleTransactions]) 
	return [[[channels objectAtIndex:0] nonretainedObjectValue]
		   evaluateExpression:@"ROLLBACK"];
    else 
	return YES;
}

- (BOOL)canNestTransactions		{ return NO; }

- (BOOL)serverCanHandleTransactions 
{
    /*
    NSString* ver = [[[channels objectAtIndex:0] nonretainedObjectValue]
			mysqlServerVersion];
    return ([ver compare: @"3.23"] != NSOrderedAscending);
    */
    return NO;
}
    

@end /* MySQLContext */
