/* 
   MySQLValues.h

   Copyright (C) 2000 Free Software Foundation, Inc.

   Author: Stephen Peters <portnoy@portnoy.org>
	      based on the Postgres95 Adaptor written by 
	   Mircea Oancea <mircea@jupiter.elcom.pub.ro>
   Date: August 2000

   This file is part of the GNUstep Database Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __MySQLValues_h__
#define __MySQLValues_h__

#include <Foundation/NSString.h>
#include <Foundation/NSValue.h>
#include <Foundation/NSData.h>
#include <Foundation/NSDate.h>
#include <Foundation/NSCalendarDate.h>
#include <eoaccess/EONull.h>

@class EOAttribute;
@class MySQLChannel;

@interface NSString (MySQLValueCreation)
+ mysqlValueFromBytes:(char*)bytes
  length:(int)length
  owned:(BOOL)owned
  attribute:(EOAttribute*)attribute
  adaptorChannel:(MySQLChannel*)channel
  zone:(NSZone*)zone;
- stringValueForMySQLType:(NSString*)type
  attribute:(EOAttribute*)attribute;
@end

@interface NSNumber (MySQLValueCreation)
+ mysqlValueFromBytes:(char*)bytes
  length:(int)length
  owned:(BOOL)owned
  attribute:(EOAttribute*)attribute
  adaptorChannel:(MySQLChannel*)channel
  zone:(NSZone*)zone;
- stringValueForMySQLType:(NSString*)type
  attribute:(EOAttribute*)attribute;
@end

@interface NSData (MySQLValueCreation)
+ mysqlValueFromBytes:(char*)bytes
  length:(int)length
  owned:(BOOL)owned
  attribute:(EOAttribute*)attribute
  adaptorChannel:(MySQLChannel*)channel
  zone:(NSZone*)zone;
- stringValueForMySQLType:(NSString*)type
  attribute:(EOAttribute*)attribute;
@end

@interface NSCalendarDate (MySQLValueCreation)
+ mysqlValueFromBytes:(char*)bytes
  length:(int)length
  owned:(BOOL)owned
  attribute:(EOAttribute*)attribute
  adaptorChannel:(MySQLChannel*)channel
  zone:(NSZone*)zone;
- stringValueForMySQLType:(NSString*)type
  attribute:(EOAttribute*)attribute;
@end

@interface EONull (MySQLValueCreation)
- stringValueForMySQLType:(NSString*)type
  attribute:(EOAttribute*)attribute;
@end

@interface NSObject (MySQLValueCreation)
+ mysqlValueFromBytes:(char*)bytes
  length:(int)length
  owned:(BOOL)owned
  attribute:(EOAttribute*)attribute
  adaptorChannel:(MySQLChannel*)channel
  zone:(NSZone*)zone;
- stringValueForMySQLType:(NSString*)type
  attribute:(EOAttribute*)attribute;
@end

#endif /* __MySQLValues_h__ */
