/*****************************************************************************
FILE:               NSArray-Oracle7Adaptor_Perform.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header: /cvsroot/gnustep/gnustep/dev-libs/db/eoadaptors/Oracle7/NSArray-Oracle7Adaptor_Perform.m,v 1.1 2000/02/22 16:27:13 pjb Exp $
    This is the implementation of the NSArray(Oracle7Adaptor_Perform) category.

    Hey! At NeXT/Apple! Just let me know when you'll make up you mind !

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log: NSArray-Oracle7Adaptor_Perform.m,v $
    Revision 1.1  2000/02/22 16:27:13  pjb
    First release of the Oracle7Adaptor.

    1999/08/02 Creation.
BUGS
    - This whole category is a BUG!
LEGAL
    Written by:  Pascal J. Bourguignon <pjb@imaginet.fr>
    Funds from:  Orange Concept (http://www.orange-concept.com/)
    Date:        August 1999 - February 2000

    This file is part of the Oracle7 Adaptor, GNUstep Database Library.
    The Oracle7 Adaptor allows access to Oracle[678] databases from GDL.

    Copyright (C) 2000 Free Software Foundation, Inc.

    This  library is  free software;  you can  redistribute  it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free  Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This library  is distributed in the  hope that it  will be useful,
    but  WITHOUT ANY WARRANTY;  without even  the implied  warranty of
    MERCHANTABILITY or FITNESS FOR  A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have  received a copy of the  GNU Lesser General Public
    License  along  with this  library;  if  not,  write to  the  Free
    Software  Foundation, Inc.,  59 Temple  Place, Suite  330, Boston,
    MA 02111-1307 USA
*****************************************************************************/
#include <NSArray-Oracle7Adaptor_Perform.h>

@implementation NSArray(Oracle7Adaptor_Perform)
    
// NSArray(Oracle7Adaptor_Perform) methods:

    -(void)oracle7AdaptorMakeThemWorkOn:(SEL)aSelector
    {
#ifdef  STRICT_OPENSTEP
#ifdef  STRICT_MACOS_X
        unsigned int index;
        unsigned int count=[self count];
        for(index=0;index<count;index++){
            [[self objectAtIndex:index]performSelector:aSelector];
        }
#else
        [self makeObjectsPerform:aSelector];
#endif
#else
        [self makeObjectsPerformSelector:aSelector];
#endif
    }//oracle7AdaptorMakeThemWorkOn:;


    -(void)oracle7AdaptorMakeThemWorkOn:(SEL)aSelector with:(id)anObject
    {
#ifdef  STRICT_OPENSTEP
#ifdef  STRICT_MACOS_X
        unsigned int index;
        unsigned int count=[self count];
        for(index=0;index<count;index++){
            [[self objectAtIndex:index]performSelector:aSelector 
                    withObject:anObject];
        }
#else
        [self makeObjectsPerform:aSelector withObject:anObject];
#endif
#else
        [self makeObjectsPerformSelector:aSelector withObject:anObject];
#endif
    }//oracle7AdaptorMakeThemWorkOn:with:;


@end //NSArray(Oracle7Adaptor_Perform);

/*** NSArray-Oracle7Adaptor_Perform.m -- 2000-02-21 07:11:16 -- PJB ***/
