/*****************************************************************************
FILE:               O2CI7Object.m
LANGUAGE:           Objective-C
SYSTEM:             None
USER-INTERFACE:     None
DESCRIPTION
    $Header: /cvsroot/gnustep/gnustep/dev-libs/db/eoadaptors/Oracle7/O2CI7Object.m,v 1.1 2000/02/22 16:27:13 pjb Exp $
    This is the implementation of the O2CI7Object class.
    The class O2CI7Object is xxxxxx.
    The implementation of the class O2CI7Object xxxxxxx.

AUTHORS
    <PJB>  Pascal J. Bourguignon  <pjb@imaginet.fr>
MODIFICATIONS
    $Log: O2CI7Object.m,v $
    Revision 1.1  2000/02/22 16:27:13  pjb
    First release of the Oracle7Adaptor.

    1999/08/08 Creation.
BUGS
    - It's not implemented yet.
LEGAL
    Written by:  Pascal J. Bourguignon <pjb@imaginet.fr>
    Funds from:  Orange Concept (http://www.orange-concept.com/)
    Date:        August 1999 - February 2000

    This file is part of the Oracle7 Adaptor, GNUstep Database Library.
    The Oracle7 Adaptor allows access to Oracle[678] databases from GDL.

    Copyright (C) 2000 Free Software Foundation, Inc.

    This  library is  free software;  you can  redistribute  it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free  Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This library  is distributed in the  hope that it  will be useful,
    but  WITHOUT ANY WARRANTY;  without even  the implied  warranty of
    MERCHANTABILITY or FITNESS FOR  A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have  received a copy of the  GNU Lesser General Public
    License  along  with this  library;  if  not,  write to  the  Free
    Software  Foundation, Inc.,  59 Temple  Place, Suite  330, Boston,
    MA 02111-1307 USA
*****************************************************************************/

#include <O2CI7Object.h>
#include <Oracle7Utilities.h>


DECLARE_SYMBOL(O2CI7Object_eBadInitializer)
DECLARE_SYMBOL(O2CI7Object_eInternalError)


@implementation O2CI7Object

    static const char* rcsid="$Id";

// NSObject methods:

    -(id)init
    {
        self=[super init];
        if(self!=nil){
            errorMessages=nil;
        }
        return(self);
    }//init;


    -(void)dealloc
    {
        [errorMessages release];
        [super dealloc];
    }//dealloc;

    
// O2CI7Object methods:


    -(NSArray*)errorMessages
    {
        if(errorMessages==nil){
            return([NSArray array]);
        }else{
            return([[errorMessages copy] autorelease]);
        }
    }//errorMessages;


    -(void)cleanErrorMessages
    {
        if(errorMessages!=nil){
            [errorMessages removeAllObjects];
        }
    }//cleanErrorMessages;


    -(void)reportErrorMessage:(NSString*)message
    {
        if(errorMessages==nil){
            errorMessages=[[NSMutableArray alloc]initWithCapacity:8];
        }
        [errorMessages addObject:message];
    }//reportErrorMessage:;




@end //O2CI7Object;

/*** O2CI7Object.m                    -- 2000-02-21 07:11:20 -- PJB ***/
