/*****************************************************************************
FILE:               Oracle7Channel-ForFriend.h
LANGUAGE:           Objective-C
SYSTEM:             GNUstep
USER-INTERFACE:     None
DESCRIPTION

    This category defines a private API of Oracle7Channel 
    used by Oracle7SQLExpression.

AUTHORS
    <PJB> Pascal J. Bourguignon <pjb@imaginet.fr>
MODIFICATIONS
    2000/02/14 <PJB> Creation.
BUGS
    - ...
LEGAL
    Written by:  Pascal J. Bourguignon <pjb@imaginet.fr>
    Funds from:  Orange Concept (http://www.orange-concept.com/)
    Date:        August 1999 - February 2000

    This file is part of the Oracle7 Adaptor, GNUstep Database Library.
    The Oracle7 Adaptor allows access to Oracle[678] databases from GDL.

    Copyright (C) 2000 Free Software Foundation, Inc.

    This  library is  free software;  you can  redistribute  it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free  Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This library  is distributed in the  hope that it  will be useful,
    but  WITHOUT ANY WARRANTY;  without even  the implied  warranty of
    MERCHANTABILITY or FITNESS FOR  A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have  received a copy of the  GNU Lesser General Public
    License  along  with this  library;  if  not,  write to  the  Free
    Software  Foundation, Inc.,  59 Temple  Place, Suite  330, Boston,
    MA 02111-1307 USA
*****************************************************************************/
#ifndef __Oracle7Channel_ForFriend_h__
#define __Oracle7Channel_ForFriend_h__

#include <Foundation/Foundation.h>  // Let's leave  the  compiler  handle 
                                    // intelligently pre-compiled headers!
#include <Oracle7Channel.h>

@interface Oracle7Channel(ForFriends)

     -(void)willSelectAttributes:(NSArray*)attributes;

@end // Oracle7Channel(ForFriends);


#endif /* __Oracle7Channel_ForFriends_h__ */

/*** Oracle7Channel-ForFriends.h      -- 2000-02-21 07:11:22 -- PJB ***/
