/*****************************************************************************
FILE:               Oracle7Utilities.h
LANGUAGE:           Objective-C
SYSTEM:             GNUstep
USER-INTERFACE:     None
DESCRIPTION

    This module exports some utilities macros and functions for the
    Oracle7Adaptor.

AUTHORS
    <PJB> Pascal J. Bourguignon <pjb@imaginet.fr>
MODIFICATIONS
    1999/07/24 Creation.
BUGS
    - ...
LEGAL
    Written by:  Pascal J. Bourguignon <pjb@imaginet.fr>
    Funds from:  Orange Concept (http://www.orange-concept.com/)
    Date:        August 1999 - February 2000

    This file is part of the Oracle7 Adaptor, GNUstep Database Library.
    The Oracle7 Adaptor allows access to Oracle[678] databases from GDL.

    Copyright (C) 2000 Free Software Foundation, Inc.

    This  library is  free software;  you can  redistribute  it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free  Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This library  is distributed in the  hope that it  will be useful,
    but  WITHOUT ANY WARRANTY;  without even  the implied  warranty of
    MERCHANTABILITY or FITNESS FOR  A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have  received a copy of the  GNU Lesser General Public
    License  along  with this  library;  if  not,  write to  the  Free
    Software  Foundation, Inc.,  59 Temple  Place, Suite  330, Boston,
    MA 02111-1307 USA
*****************************************************************************/
#ifndef __Oracle7Utilities_h__
#define __Oracle7Utilities_h__
#include <Foundation/Foundation.h>


    extern NSBundle* Oracle7Utilities_Bundle(void);
        /*
            RETURN:     The bundle from which the Oracle7Adaptor class 
                        has been loaded.
        */

// If self->isa isn't a class, then it's a metaclass and self is a class.

#define NOT_IMPLEMENTED_YET \
        NSLog(@"%c[%@ %@] is not implemented yet.",\
            CLS_ISCLASS(self->isa)?'-':'+',\
            NSStringFromClass([self class]),\
            NSStringFromSelector(_cmd));


#define CURRENT_METHOD \
        [NSString stringWithFormat:@"%c[%@ %@]",\
            CLS_ISCLASS(self->isa)?'-':'+',\
            NSStringFromClass([self class]),\
            NSStringFromSelector(_cmd)]

#define CURRENT_METHOD_AND(p) \
        [NSString stringWithFormat:@"%c[%@ %@]%@",\
            CLS_ISCLASS(self->isa)?'-':'+',\
            NSStringFromClass([self class]),\
            NSStringFromSelector(_cmd),\
            (p)]

#define DECLARE_SYMBOL(p)  NSString* p=@ ## #p;



#endif // __Oracle7Utilities_h__
/*** Oracle7Utilities.h               -- 2000-02-21 07:11:23 -- PJB ***/
