/* 
   NGObjCCategory.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGObjCCategory.h,v 1.1 2000/03/20 15:45:33 mguesdon Exp $

#ifndef __NGReflection_NGObjCCategory_H__
#define __NGReflection_NGObjCCategory_H__

#import <Foundation/NSObject.h>

@class NSString, NSMutableArray, NSEnumerator, NSDictionary;
@class NGObjCMethod;

@interface NGObjCCategory : NSObject
{
@protected
  Class          class;
  NSString       *name;
  NSMutableArray *instanceMethods;
  NSMutableArray *classMethods;
  NSMutableArray *protocols;

  void *internalRepresentation;
}

+ (id)category:(NSString *)_name forClass:(Class)_class;
+ (id)category:(NSString *)_name forClassNamed:(NSString *)_className;

// accessors

- (NSString *)categoryName;
- (Class)categoryClass;

- (NSEnumerator *)instanceMethods;
- (NSEnumerator *)classMethods;
- (NSEnumerator *)protocols;

- (void)addInstanceMethod:(NGObjCMethod *)_method;
- (void)removeInstanceMethod:(NGObjCMethod *)_method;

- (void)addClassMethod:(NGObjCMethod *)_method;
- (void)removeClassMethod:(NGObjCMethod *)_method;

// representation

- (void *)internalRepresentation;

// description

- (NSDictionary *)propertyList;

@end

#endif /* __NGReflection_NGObjCCategory_H__ */
