/* 
   NGObjCInternals.h

   Copyright (C) 1998 MDlink online service center, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge@mdlink.de)

   This file is part of the MDlink Object Framework 2 (MOF2)

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGObjCInternals.h,v 1.1 2000/03/20 15:45:34 mguesdon Exp $

#ifndef __NGReflection_NGObjCInternals_H__
#define __NGReflection_NGObjCInternals_H__

#include <objc/objc.h>
#include <objc/objc-api.h>

@class NSArray, NSString;

MethodList_t _makeMethodList(NSArray *_methods);
NSArray      *_makeMethods(MethodList_t _methods);

struct objc_protocol_list *_makeProtocolList(NSArray *_protocols);

Category_t _makeCategory(NSString *_name, Class _class,
                         NSArray *_instanceMethods,
                         NSArray *_classMethods,
                         NSArray *_protocols);

#ifdef LIB_FOUNDATION_BOEHM_GC
BOOL ivar_get_gcinvisible(Ivar_t _ivar);
#endif

NSString *NGTypeAsObjectiveCString(const char *_type);

#endif /* __NGReflection_NGObjCInternals_H__ */
