/** GSWComponentRequestHandler.h - <title>GSWeb: Class GSWComponentRequestHandler</title>

   Copyright (C) 1999-2002 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 	Feb 1999
   
   $Revision: 1.2 $
   $Date: 2002/08/04 18:00:10 $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWComponentRequestHandler.h,v 1.2 2002/08/04 18:00:10 mguesdon Exp $

#ifndef _GSWComponentRequestHandler_h__
	#define _GSWComponentRequestHandler_h__


@interface GSWComponentRequestHandler: GSWRequestHandler
{
}

-(GSWResponse*)handleRequest:(GSWRequest*)aRequest;
-(GSWResponse*)lockedHandleRequest:(GSWRequest*)aRequest;
-(GSWResponse*)lockedDispatchWithPreparedApplication:(GSWApplication*)application
                                           inContext:(GSWContext*)aContext
                                            elements:(NSDictionary*)elements;
-(GSWResponse*)lockedDispatchWithPreparedSession:(GSWSession*)aSession
                                       inContext:(GSWContext*)aContext
                                        elements:(NSDictionary*)elements;
-(GSWResponse*)lockedDispatchWithPreparedPage:(GSWComponent*)_component
                                    inSession:(GSWSession*)aSession
                                    inContext:(GSWContext*)aContext
                                     elements:(NSDictionary*)elements;
-(GSWComponent*)lockedRestorePageForContextID:(NSString*)aContextID
                                    inSession:(GSWSession*)aSession;

@end

//====================================================================
@interface GSWComponentRequestHandler (GSWRequestHandlerClassA)
+(id)handler;
+(NSDictionary*)_requestHandlerValuesForRequest:(GSWRequest*)aRequest;
@end

#endif //_GSWComponentRequestHandler_h__
