/** GSWGenericContainer.h - <title>GSWeb: Class GSWGenericContainer</title>

   Copyright (C) 1999-2002 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 		Jan 1999
   
   $Revision: 1.3 $
   $Date: 2002/08/04 18:00:10 $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWGenericContainer.h,v 1.3 2002/08/04 18:00:10 mguesdon Exp $

#ifndef _GSWGenericContainer_h__
	#define _GSWGenericContainer_h__


//====================================================================
@interface GSWGenericContainer: GSWDynamicElement
{
  GSWAssociation* _children;
  NSDictionary* _associations;
  GSWElement* _element;
};

-(id)initWithName:(NSString*)aName
     associations:(NSDictionary*)associations
         template:(GSWElement*)templateElement;
-(void)dealloc;
-(NSString*)description;

-(void)appendToResponse:(GSWResponse*)aResponse
			  inContext:(GSWContext*)aContext;

-(GSWElement*)invokeActionForRequest:(GSWRequest*)aRequest
                           inContext:(GSWContext*)aContext;

-(void)takeValuesFromRequest:(GSWRequest*)aRequest
                   inContext:(GSWContext*)aContext; 

@end

#endif //_GSWGenericContainer_h__
