/** GSWTextField.h - <title>GSWeb: Class GSWTextField</title>

   Copyright (C) 1999-2002 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 		Jan 1999
   
   $Revision: 1.3 $
   $Date: 2002/05/14 11:28:50 $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWTextField.h,v 1.3 2002/05/14 11:28:50 mguesdon Exp $

#ifndef _GSWTextField_h__
	#define _GSWTextField_h__

//OK
@interface GSWTextField: GSWInput
{
  GSWAssociation* _dateFormat;
  GSWAssociation* _numberFormat;
  GSWAssociation* _useDecimalNumber;
  GSWAssociation* _formatter;
};
-(id)initWithName:(NSString*)name
     associations:(NSDictionary*)associations
  contentElements:(NSArray*)elements;
-(void)dealloc;
-(void)takeValuesFromRequest:(GSWRequest*)request
                   inContext:(GSWContext*)context; 
-(void)appendGSWebObjectsAssociationsToResponse:(GSWResponse*)response
                                      inContext:(GSWContext*)context; 
-(NSFormatter*)formatterForComponent:(GSWComponent*)component;
@end

@interface GSWTextField (TurbocatAdditions)
- (BOOL)_isFormattedValueInComponent:(GSWComponent *)component  
               equalToFormattedValue:(NSString *)newFormattedValue ;
@end

#endif //_GSWTextField_h__
